//
//  View.m
//  Sine
//
//  Created by NYU User on 11/3/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "View.h"

@implementation View

- (id) initWithFrame: (CGRect) frame
{
	self = [super initWithFrame: frame];
	if (self) {
		// Initialization code
		self.backgroundColor = [UIColor whiteColor];
	}
	return self;
}


// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void) drawRect: (CGRect) rect
{
	// Drawing code
	CGContextRef c = UIGraphicsGetCurrentContext();

	//Place the origin at the center of view.
	CGSize size = self.bounds.size;
	CGAffineTransform translate = CGAffineTransformMakeTranslation(
		size.width / 2,
		size.height / 2
	);

	//Graph sine as x goes from -2pi to +2pi,
	//drawing 2 complete sine waves.
	CGFloat width = 4 * M_PI;
	CGFloat scale = size.width / width;

	//Make Y axis point up.
	CGAffineTransform sineScale = CGAffineTransformMakeScale(scale, -scale);

	//Axes
	CGContextConcatCTM(c, translate);
	CGContextBeginPath(c);

	//X axis
	CGContextMoveToPoint(c, -size.width / 2, 0);
	CGContextAddLineToPoint(c, size.width / 2, 0);

	//Y axis
	CGContextMoveToPoint(c, 0, size.height / 2);
	CGContextAddLineToPoint(c, 0, -size.height / 2);

	CGContextSetRGBStrokeColor(c, 0, 0, 1, 0.5);
	CGContextStrokePath(c);

	//Graph of sine function.
	CGContextConcatCTM(c, sineScale);
	CGContextBeginPath(c);

	BOOL first = YES;
	for (CGFloat x = -2 * M_PI; x <= 2 * M_PI; x += 1 / scale) {
		CGFloat y = sinf(x);				//Punchline.

		if (first) {
			first = NO;
			CGContextMoveToPoint(c, x, y);	//first iteration of loop
		} else {
			CGContextAddLineToPoint(c, x, y);
		}
	}

	assert(scale != 0);	//Don't risk division by 0.
	CGContextSetLineWidth(c, 1 / scale);
	CGContextSetRGBStrokeColor(c, 0.0, 0.0, 0.0, 1.0);
	CGContextStrokePath(c);
}


@end
